Set WshShell = CreateObject("WScript.Shell")
Set fso = CreateObject("Scripting.FileSystemObject")
CurrentPath = Left(WScript.ScriptFullName, Len(WScript.ScriptFullName) - Len(WScript.ScriptName) - 1)
' CurrentPath: without trailing backslash!

'---------- WshExtra.Clipboard 
On Error Resume Next
Set Clip = CreateObject ("WshExtra.Clipboard")             'first attempt
If Err<>0 Then     'WshExtra.dll is not registered. Trying to register...
   Err.Clear
   WshShell.Run "regsvr32.exe /s " & Chr(34) & CurrentPath & "\WshExtra.dll" & Chr(34),,True
   Set Clip = CreateObject ("WshExtra.Clipboard")          'second attempt
   If Err<>0 Then 
      MsgBox "Cannot create object WshExtra.Clipboard"
      WScript.Quit
   End If
End If
On Error GoTo 0


'---------- ADODB.Stream
On Error Resume Next
Set Stm = CreateObject("ADODB.Stream")
If Err<>0 Then     'ADO is not registered.
   MsgBox "Cannot create object ADODB.Stream." & vbCRLF & "You need to install Microsoft ADO."
   WScript.Quit
End If
On Error GoTo 0

Stm.Open
Stm.Charset = "US-ASCII"
Stm.WriteText Clip.Paste

'---------- CDO.Message
On Error Resume Next
Set Msg = CreateObject("CDO.Message")
If Err<>0 Then     'CDO is not registered.
   MsgBox "Cannot create object CDO.Message." & vbCRLF & "You need to install Microsoft CDO."
   WScript.Quit
End If
On Error GoTo 0

Set iDsrc = Msg.DataSource
iDsrc.OpenObject Stm, "_Stream"


'---------- message parsing

Set BodyParts = Msg.Attachments        'is Collection of BodyParts
'MsgBox "AttachmentsCount: " & BodyParts.Count

Dim AttachmentFileName(100)
Dim AttachmentBodyPartNumber(100)
CounterAttachment = 0
CounterBodyPart = 1            ' is 1-based !!!         
                               ' (     )
ListOfAttachments = ""

If BodyParts.Count > 0 Then
   For CounterBodyPart = 1 To BodyParts.Count
      Set CurrentPart = BodyParts(CounterBodyPart)
      If CurrentPart.FileName <> "" Then
         AttachmentFileName(CounterAttachment) = CurrentPart.Filename
         AttachmentBodyPartNumber(CounterAttachment) = CounterBodyPart
         ListOfAttachments = ListOfAttachments & CurrentPart.Filename & vbCRLF
         CounterAttachment = CounterAttachment + 1
      End If
   Next

   If BodyParts.Count <> CounterAttachment Then
      MsgBox "Interesting..." & vbCRLF & "BodyParts.Count <> CounterAttachment" & vbCRLF & vbCRLF & _
         "BodyParts.Count = " & BodyParts.Count & vbCRLF & _
         "CounterAttachment = " & CounterAttachment & vbCRLF & vbCRLF & _
         "You can continue with saving."
   End If

   If CounterAttachment > 0 Then             'Attachments found
      SavePath = WshShell.SpecialFolders("Desktop")
      If Right(SavePath,1) <> "\" Then SavePath = SavePath & "\"           'display with trailing backslash
      InvalidFolderInfo = ""
      SavePathAbsolute = ""

      Do
         SavePath = InputBox(ListOfAttachments & vbCRLF & vbCRLF & vbCRLF & _
           "Save to (existing files will be overwritten):" & InvalidFolderInfo, _
           "Save Attachments (" & CounterAttachment & ")", SavePath)
         If SavePath = "" Then WScript.Quit  'Cancel was pressed
         SavePath = Trim(SavePath)
         If Right(SavePath,1) = "\" Then SavePath = Mid(SavePath, 1, Len(SavePath)-1)
         If Left(SavePath,1) = "\" Then SavePath = Mid(SavePath, 2)
         On Error Resume Next
         If fso.FolderExists(SavePath) Then
            InvalidFolderInfo = ""
            SavePathAbsolute = fso.GetAbsolutePathName(SavePath)
            Set fol = fso.GetFolder(SavePath)
'           MsgBox "SavePath=" & SavePath & vbCRLF & "SavePathAbsolute=" & SavePathAbsolute & vbCRLF & "fol.Path=" & fol.Path           'debug
            If Mid(SavePath, 2, 1) <> ":" Then 
               SavePath = SavePathAbsolute
               MsgBox "Will be saved to: " & vbCRLF & SavePath & "\"
            End If
         Else
            InvalidFolderInfo = vbCRLF & "YOU HAVE CHOOSED AN INVALID OR NON-EXISTING FOLDER. PLEASE CORRECT"
            If Err<>0 Then 
               InvalidFolderInfo = InvalidFolderInfo & vbCRLF & "Error Number: " & Err
               Err.Clear
            End If
         End If
         On Error GoTo 0
      Loop Until InvalidFolderInfo = ""
   
      For i = 0 To CounterAttachment-1
         Set CurrentPart = BodyParts(AttachmentBodyPartNumber(i))
         'MsgBox SavePath & "\" & AttachmentFileName(i)    'debug
         CurrentPart.SaveToFile SavePath & "\" & AttachmentFileName(i)
         ' it seems, filenames will be saved in ANSI (system locale codepage), not in Unicode 
         ' (e.g. no german umlauts saved with Cyrillic (Win-1251) system locale)
      Next
   Else
      MsgBox "No attachments found!"
   End If
Else
   MsgBox "No BodyParts found!"
End If







WScript.Quit



